﻿using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Data;
using HeuristicLab.Encodings.IntegerVectorEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using System.Linq;

namespace HeuristicLab.BioBoost.SolutionCreation {

  [StorableClass]
  public class IdentityIntegerVectorCreator : IntegerVectorCreator {

    #region Construction & Cloning
    [StorableConstructor]
    protected IdentityIntegerVectorCreator(bool isDeserializing) : base(isDeserializing) {}
    protected IdentityIntegerVectorCreator(IdentityIntegerVectorCreator orig, Cloner cloner) : base(orig, cloner) {}
    public IdentityIntegerVectorCreator() { }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new IdentityIntegerVectorCreator(this, cloner);
    }
    #endregion

    protected override IntegerVector Create(IRandom random, IntValue length, IntMatrix bounds) {
      return new IntegerVector(Enumerable.Range(0, length.Value).ToArray());
    }

  }
}
