﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using HeuristicLab.Core;
using HeuristicLab.Random;

namespace HeuristicLab.BioBoost.Utils {
  public class Util {

    public static double Distance(Point p1, Point p2) {
      return Math.Sqrt(Sqr(p1.X - p2.X) + Sqr(p1.Y - p2.Y));
    }

    public static double Sqr(double x) { return x * x; }

    public static void Shuffle<T>(T[] elements, IRandom random) {
      for (int i = elements.Length - 1; i > 0; i--) {
        // Swap element "i" with a random earlier element (including itself)
        int swapIndex = random.Next(i + 1);
        T temp = elements[swapIndex];
        elements[swapIndex] = elements[i];
        elements[i] = temp;
      }
    }

    public static T[] Clone<T>(T[] t) {
      return (T[]) (t == null ? null : t.Clone());
    }

    public static T Clone<T>(T t) where T : ICloneable {
      return (T) (t == null ? null : t.Clone());
    }

  }
}
